//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@HardcoreProcessing.com


#ifndef __NODE__    
#define __NODE__

class NodeList;
class NamedNodeMap;

#include "domDefs.idl"
#include "DOMException.idl"
#include "NodeList.idl"
#include "NamedNodeMap.idl"

class Node
{
public:
  virtual CORBA::WString nodeName(void);
  virtual void nodeValue(CORBA::WString _value);
  virtual CORBA::WString nodeValue(void);
  virtual CORBA::UShort nodeType(void);
  virtual Node *parentNode(void);
  virtual NodeList *childNodes(void);
  virtual Node *firstChild(void);
  virtual Node *lastChild(void);
  virtual Node *previousSibling(void);
  virtual Node *nextSibling(void);
  virtual NamedNodeMap *attributes(void);
  virtual Node *ownerDocument(void);
  virtual Node *insertBefore(Node *newChild, Node *refChild);
  virtual Node *replaceChild(Node *newChild, Node *oldChild);
  virtual Node *removeChild(Node *oldChild);
  virtual Node *appendChild(Node *newChild);
  virtual CORBA::Boolean hasChildNodes(void);
  virtual Node *cloneNode(CORBA::Boolean deep);
  virtual void setParentNode__(Node *newParent);
  virtual void setPreviousSibling__(Node *newPrevSib);
  virtual void setNextSibling__(Node *newNextSib);
};

#endif
